package org.apache.commons.lang3.time;

package .tmp;

import java.util.Calendar;
import org.apache.commons.lang3.time.FastDateParser;

class StrategyParser {
  private final Calendar definingCalendar;
  
  private int currentIdx;
  
  StrategyParser(Calendar definingCalendar) {
    this.definingCalendar = definingCalendar;
  }
  
  FastDateParser.StrategyAndWidth getNextStrategy() {
    if (this.currentIdx >= FastDateParser.access$000(FastDateParser.this).length())
      return null; 
    char c = FastDateParser.access$000(FastDateParser.this).charAt(this.currentIdx);
    if (FastDateParser.access$100(c))
      return letterPattern(c); 
    return literal();
  }
  
  private FastDateParser.StrategyAndWidth letterPattern(char c) {
    int begin = this.currentIdx;
    do {
    
    } while (++this.currentIdx < FastDateParser.access$000(FastDateParser.this).length() && 
      FastDateParser.access$000(FastDateParser.this).charAt(this.currentIdx) == c);
    int width = this.currentIdx - begin;
    return new FastDateParser.StrategyAndWidth(FastDateParser.access$200(FastDateParser.this, c, width, this.definingCalendar), width);
  }
  
  private FastDateParser.StrategyAndWidth literal() {
    boolean activeQuote = false;
    StringBuilder sb = new StringBuilder();
    while (this.currentIdx < FastDateParser.access$000(FastDateParser.this).length()) {
      char c = FastDateParser.access$000(FastDateParser.this).charAt(this.currentIdx);
      if (!activeQuote && FastDateParser.access$100(c))
        break; 
      if (c == '\'' && (++this.currentIdx == FastDateParser.access$000(FastDateParser.this).length() || FastDateParser.access$000(FastDateParser.this).charAt(this.currentIdx) != '\'')) {
        activeQuote = !activeQuote;
        continue;
      } 
      this.currentIdx++;
      sb.append(c);
    } 
    if (activeQuote)
      throw new IllegalArgumentException("Unterminated quote"); 
    String formatField = sb.toString();
    return new FastDateParser.StrategyAndWidth(new FastDateParser.CopyQuotedStrategy(formatField), formatField.length());
  }
}
